﻿Option Strict On
Imports System.Xml.Linq
Imports System.Net

Public Class AddressInfo
    Property zipcode As String
    Property prefecture As String
    Property city As String
    Property town As String
End Class
Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' Constructor
    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub MainPage_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        Dim xmldoc As XElement = XElement.Load("pref.xml")
        Dim prefList As New List(Of String)

        For Each result In From c In xmldoc.Descendants("都道府県") Select c
            prefList.Add(result.Value)
        Next
        prefListBox.ItemsSource = prefList
    End Sub

    Private Sub prefListBox_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles prefListBox.SelectionChanged
        TextBox1.Text = prefListBox.SelectedItem.ToString
        Button1.IsEnabled = True
    End Sub

    Private Sub Button1_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles Button1.Click
        Dim myUri As String = String.Format("http://api.postalcode.jp/v1/zipsearch/v1/zipsearch?word={0}&format=xml", TextBox1.Text)
        Dim myWebClient As New WebClient
        myWebClient.DownloadStringAsync(New Uri(myUri, UriKind.Absolute))

        AddHandler myWebClient.DownloadStringCompleted, Sub(resultSender As Object, resultArgs As DownloadStringCompletedEventArgs)
                                                            Dim xmldoc As XElement = XElement.Parse(resultArgs.Result)

                                                            Dim myAddressInfo As New List(Of AddressInfo)
                                                            For Each result In From c In xmldoc.Descendants("address") Select c
                                                                With myAddressInfo
                                                                    .Add(New AddressInfo With {.zipcode = result.Element("zipcode").Value,
                                                                                            .prefecture = result.Element("prefecture").Value,
                                                                                            .city = result.Element("city").Value,
                                                                                            .town = result.Element("town").Value})
                                                                End With
                                                            Next
                                                            resultListBox.ItemsSource = myAddressInfo
                                                        End Sub
    End Sub
End Class
